/*
Copyright ＿ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.
*/

var kVersion = "0.3.8";

var kMaxSymbols = 35;
var kRefreshPeriod = 120000;	/* ms */
var allTheData = [{symbol:'^GDAXI', exchange:"XETRA", display:"DAX", name:"German DAX", lasttrade:0, change:0, pctchange:0},
				 {symbol:'SIE.DE', exchange:"XETRA", display:'', name:"SIEMENS N", lasttrade:0, change:0, pctchange:0},
				 {symbol:'^FTSE', exchange:"London", display:"FTSE", name:"FTSE 100", lasttrade:0, change:0, pctchange:0},
				 {symbol:'^IXIC', exchange:"NASDAQ", display:"NASDAQ", name:"NASDAQ COMPOSITE", lasttrade:0, change:0, pctchange:0},
				 {symbol:'^GSPC', exchange:"", display:"S&P 500", name:"S&amp;P 500 INDEX, RTH", lasttrade:0, change:0, pctchange:0}
				];
var symbolData = new Array();


var kColorthememapInfo = [
				{folder:"Images.brown", left:"19px", top:"255px"},
				{folder:"Images.blue", left:"41px", top:"255px"},
				{folder:"Images.cyan", left:"63px", top:"255px"},
				{folder:"Images.purple", left:"85px", top:"255px"},
				{folder:"Images.graphite", left:"107px", top:"255px"} ];

var editRolloverImg = null;
var showingCharts = true;

var addButton = null;
var renameButton = null;
var removeButton = null;

var currentSelection = null;
var anythingChangedOnBackside = false;
var currentChartMode = '3m';
var isShowingFront = true;
var allMarketsOpen = true;
var timer = null;
var lastDownloadDate = null;

var kChartCanvasWidth = 144;
var kChartCanvasHeight = 48;
var kOffsetBtCanvasAndXAxes = 7;

var kMenuAddAnywayMarker = 66666;

var selectedSymbol = null;	// used during setupWidget


var DAY_CHART_MAX_LABEL_ADJUST = .75;
var WEEK_CHART_UNFINISHED_MINUTES = 20;

var gTimezoneOffsetInMin = (new Date()).getTimezoneOffset();

var chartModes = ['1d', '1w', '1m', '3m', '6m', '1y', '2y'];

var kKeyUpArrow = 63232;
var kKeyDownArrow = 63233;
var kKeyLeftArrow = 63234;
var kKeyRightArrow = 63235;

//
// Extensions to Javascript objects or DOM processing
//

function $(id) {
	return document.getElementById(id);
}

Array.prototype.swap = function(index1,index2) {
	var temp = this[index1];
	this[index1] = this[index2];
	this[index2] = temp;
	return;
}

Array.prototype.clone = function () {
	return ((new Array()).concat(this));
}

// forEach is a JavaScript extension to the ECMA-262 standard; as such it may not be present in other implementations of the standard. JavaScript 1.6 
if (!Array.prototype.forEach)
{
  Array.prototype.forEach = function(fun /*, thisp*/)
  {
    var len = this.length;
    if (typeof fun != "function")
      throw new TypeError();

    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in this)
        fun.call(thisp, this[i], i, this);
    }
  };
}

// Works only if (index of n1 in parentNode) < (index of n2)
function DOMNode_swapNode(n1,n2)
{
	n2.parentNode.removeChild(n2);
	n1.parentNode.insertBefore(n2,n1);
}


//
// Actual code for iStocks...
//

function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined) {
			ret = key;
		}
		return ret;
	} catch (ex) {}

	return key;
}

function symbolSortFunction(a,b)
{
	if (a.pctchange == N_A_CONST) {
		return 1;
	}
	if (b.pctchange == N_A_CONST) {
		return -1;
	}
	return b.pctchange - a.pctchange;
}


function getPrettySymbol (data)
{
	return (data.display === undefined || data.display == null || data.display == '') ? data.symbol : data.display;
}

function updateStatusText()
{
	if (lastDownloadDate != null)
	{
		// Update our "last updated" timer
		var curDate = new Date();
		var dateDiff = curDate.getTime() - lastDownloadDate.getTime();
		dateDiff = Math.round(dateDiff / 1000); // to seconds
				
		if (allMarketsOpen)
		{
			if (dateDiff < 60)
			{
				$('delayed').innerText = getLocalizedString("Delayed up to 20 minutes"); // "Quotes just updated"
			}
			else if (dateDiff < 120)
			{
				$('delayed').innerText = getLocalizedString("Quotes last updated one minute ago");
			}
			else if (dateDiff < 3600)
			{
				$('delayed').innerText = getLocalizedString("Quotes last updated %@ minutes ago").replace("%@", Math.round(dateDiff / 60));
			}
			else if (curDate.getDate() == lastDownloadDate.getDate() &&
					 curDate.getMonth() == lastDownloadDate.getMonth() &&
					 curDate.getFullYear() == lastDownloadDate.getFullYear()) // same day
			{
				$('delayed').innerText = getLocalizedString("Quotes last updated at %@").replace("%@", lastDownloadDate.toLocaleTimeString("short"));
			}
			else // different day
			{
				$('delayed').innerText = getLocalizedString("Quotes last updated on %@").replace("%@", lastDownloadDate.toLocaleDateString("short"));
			}
		}
		else // markets closed
		{
			if (dateDiff < 3600) // simplify more common case, also better close to day changeover
			{
				$('delayed').innerText = getLocalizedString("Markets closed (%@)").replace("%@", lastDownloadDate.toLocaleTimeString("short"));
			}
			else if (curDate.getDate() == lastDownloadDate.getDate() &&
					 curDate.getMonth() == lastDownloadDate.getMonth() &&
					 curDate.getFullYear() == lastDownloadDate.getFullYear()) // same day
			{
				$('delayed').innerText = getLocalizedString("Markets closed (%@)").replace("%@", lastDownloadDate.toLocaleTimeString("short"));
			}
			else // different day
			{
				$('delayed').innerText = getLocalizedString("Markets closed (%@)").replace("%@", lastDownloadDate.toLocaleDateString("short"));
			}
		}
	}
	else
	{
		$('delayed').innerText = getLocalizedString("Retrieving Data…"); // we just started with no data
	}
}


function truncatePrecision (string, places)
{
	var index = string.lastIndexOf('.');
	if (index < 0) {return string}

	var len = string.length;
	var precision = (len - 1) - index;
	
	if (precision > places)
	{
		return string.slice (0, len - (precision - places));
	}
	
	return string;
}


function quotes_callback(object, symbolIndices)
{
	if (!object.error)
	{
		var c = object.quotes.length;
  		for (var i = 0; i < c; ++i)
  		{
  			try 
  			{
				var quote = object.quotes[i];
				
				var change = quote.change;
				var pctchange = quote.pctchange;
				var lasttrade = quote.lasttrade;

				var showpercent = getShowPercent();
				symbolData[symbolIndices[i]] = quote;

				var change_div = $(quote.symbol+"_change");
				var last_trade_span = $(quote.symbol+"_lastTrade");
				var percent_div = $(quote.symbol+"_percent");

				// parent is row (created in createrow()); used to sort rows by performance
				last_trade_span.parentNode.pctchange = pctchange;


				// var precision = isCurrencySymbol(quote.symbol) ? 4 : 2;
				// if (change != N_A_CONST)
				// 	change =  truncatePrecision(change, precision);
				if (pctchange != N_A_CONST) {
					pctchange = truncatePrecision(pctchange, 2);
				}
				// lasttrade = truncatePrecision(lasttrade, precision);

				var background_icon = $(quote.symbol+"_icon");
				
				if (change < 0 || pctchange < 0)
				{
					background_icon.style.backgroundImage = "url(Images/down.png)";
					if (change != N_A_CONST) {
						change = change.substr(1);
					}
					if (pctchange != N_A_CONST) {
						pctchange = pctchange.substr(1);
					}
				}
				else if (change == N_A_CONST && pctchange == N_A_CONST)
				{
					background_icon.style.backgroundImage = "url(Images/na.png)";
				}
				else
				{
					// percentages can comeback -0.00.  strip the negative in this case.
					if (pctchange[0] == "-") {
						pctchange = pctchange.substr(1);
					}
					background_icon.style.backgroundImage = "url(Images/up.png)";
				}
				
				//
				// [ouch] position dependent code (firstChild).  Not the best.
				//
				last_trade_span.innerText = lasttrade;
				change_div.innerText = change;
				percent_div.innerText = pctchange + (pctchange != N_A_CONST ? "%" : "");

				if (!showpercent)
				{
					change_div.style.fontSize = "13px";
					changeFontOfElement(change_div, 41);
				}
				else
				{
					percent_div.style.fontSize = "12px";
					changeFontOfElement(percent_div, 41);
				}
				
				// Store last downloaded time
				lastDownloadDate = new Date();
			} catch (ex)
			{
				// dont let one exception lose all the data
				alert(ex.name + ". " + ex.message);
			}
		}

		if (getShowSorted()) {
			sortSymbolRows();
		}

		if (object.open != allMarketsOpen)
		{
			allMarketsOpen = object.open;
		}
	}
	else
		alert ("Stocks Widget: XMLHttpRequest Failed (" + object.errorString + ")");
	
	// Regardless of what happened above
	updateStatusText(); // "Quotes just updated" or "Last updated xx minutes ago"
}


function createRow (object)
{
	var theSymbol = object.symbol;
	var showPercent = getShowPercent();
	var prettySymbol = getPrettySymbol(object);
				
	var row = document.createElement('tr');

	row.setAttribute ("class", "stockRow");
	row.setAttribute ("onclick", "clickonrow(event, this);");
	row.setAttribute ("ondblclick", "clickedOnSymbol(this.getAttribute('tag'), this.getAttribute('stock_exchange'));");
	row.setAttribute ("tag", theSymbol);
	row.setAttribute ("stock_exchange", object.exchange);
	
	var td = document.createElement ('td');
	td.setAttribute ("class", "symbol");
	td.appendChild (document.createTextNode(prettySymbol.substr(0,9)));
	row.appendChild (td);
	
	td = document.createElement('td');
	td.setAttribute ("class", "value");
	td.setAttribute ("id", theSymbol + "_lastTrade");
	row.appendChild (td);
	
	td = document.createElement('td');
	var div = document.createElement('div');
	div.setAttribute ("class", "updown");
	div.setAttribute ("id", theSymbol + "_icon");
	div.setAttribute ("onclick", "handleRowClick(event);");
	
	var table = document.createElement('table');
	table.setAttribute ('class', 'inner-table');
	table.setAttribute ('cellspacing', '0');
	table.setAttribute ('cellpadding', '0');
	
	var tbody = document.createElement ('tbody');
	var tr = document.createElement ('tr');
	var innertd = document.createElement ('td');
	var innerdiv = document.createElement ('div');
	
	innerdiv.setAttribute ('class', showPercent ? 'change hidden' : 'change');
	innerdiv.setAttribute ('id', theSymbol + "_change");
	innertd.appendChild(innerdiv);
	
	innerdiv = document.createElement ('div');
	innerdiv.setAttribute ('class', showPercent ? 'change' : 'change hidden');
	innerdiv.setAttribute ('id', theSymbol + "_percent");
	innertd.appendChild(innerdiv);

	tr.appendChild (innertd);
	tbody.appendChild(tr);
	table.appendChild(tbody);
	div.appendChild (table);
	td.appendChild (div);
	row.appendChild (td);
		
	return row;
}


var colorThemeIdx = 0;
var colorThemeIdxFetched = false;
function getColorThemeIdx(forceFetch)
{
	if (forceFetch || !colorThemeIdxFetched)
	{
		if (window.widget)
		{
			var pref = null;
			// this is crashing TOT WebKit.  It should not but it is. turning off for now.
			var pref = widget.preferenceForKey(createKey("colortheme"));
			
			if (pref != null && parseInt(pref) >= 0 && parseInt(pref) < kColorthememapInfo.length) {
				colorThemeIdx = parseInt(pref);
			}
			else {
				colorThemeIdx = 0;
			}
		}
		colorThemeIdxFetched = true;	
	}
	
	return colorThemeIdx;
}

function setColorThemeIdx(idx)
{
	colorThemeIdx = idx;
	if (window.widget) {
		widget.setPreferenceForKey(idx+"", createKey("colortheme"));
	}
}



var showPercent = true;
var showPercentFetched = false;
function getShowPercent(forceFetch)
{
	if (forceFetch || !showPercentFetched)
	{
		if (window.widget)
		{
			var pref = null;
			// this is crashing TOT WebKit.  It should not but it is. turning off for now.
			var pref = getPreferenceForKey("show-percent", true, "true");
			showPercent = pref != null && pref.length > 1;
		}
		showPercentFetched = true;	
	}
	
	return showPercent;
}

function setShowPercent(show_percent)
{
	showPercent = show_percent;
	if (window.widget)
	{
		var pref = show_percent ? "true" : "";
		setPreferenceForKey(pref, "show-percent");
	}
}



var showSorted = true;
var showSortedFetched = false;
function getShowSorted(forceFetch)
{
	if (forceFetch || !showSortedFetched)
	{
		if (window.widget)
		{
			var pref = null;
			// this is crashing TOT WebKit.  It should not but it is. turning off for now.
			var pref = getPreferenceForKey("show-sorted", true, "");
			showSorted = pref != null && pref.length > 1;
		}
		showSortedFetched = true;	
	}
	
	return showSorted;
}

function setShowSorted(show_sorted)
{
	showSorted = show_sorted;
	if (window.widget)
	{
		var pref = show_sorted ? "true" : "";
		setPreferenceForKey(pref, "show-sorted");
	}
}



function showbackside(event) {
	var front = $("front");
	var back = $("back");

	resizedWhenFlippedOver = false;
	if (window.widget)
	{
		if (calculateWidgetHeight() < 325)
		{
			window.resizeTo (213, 325);
			resizedWhenFlippedOver = true;
		}
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display="none";
	back.style.display="block";
	isShowingFront = false;
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
	
	anythingChangedOnBackside = false;
	
	if (timer != null)
	{
		clearInterval (timer);
		timer = null;
	}

	document.removeEventListener("keypress", keyPressed, true);
	document.addEventListener("keypress", backsideKeyPressed, true);
	
	selectAllInSymbolTextField();

	event.stopPropagation();
	event.preventDefault();
}


var resizedWhenFlippedOver = false;
function selectDone ()
{
	var front = $("front");
	var back = $("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	
	front.style.display="block";
	back.style.display="none";
	
	isShowingFront = true;
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);
	}
		
	if (anythingChangedOnBackside)
	{
		updateSymbolRowsAndSelection();
	
		if (window.widget)
		{
			resizedWhenFlippedOver = true; // good chance it will need to be resized
			
			// save of the new prefs
			
			var pref = createAllDataJSString();
			setPreferenceForKey (pref, "symbols");
		}
	}
	
	onshow();

	if (showingCharts)
	{
		getChartForCurrentMode();
	}
	if (resizedWhenFlippedOver)
	{
		window.resizeTo(213, calculateWidgetHeight());
		resizedWhenFlippedOver = false;
	}

	document.removeEventListener("keypress", backsideKeyPressed, true);
	document.addEventListener("keypress", keyPressed, true);
}

function updateSymbolRowsAndSelection()
{
	// fix up widget
	var lastSelected = null;
	
	if (currentSelection != null) {
		lastSelected = currentSelection.getAttribute("tag");
	}
		
	setupMainTable (false);
	
	if (lastSelected != null)
	{
		var c = allTheData.length;
		var found = false;
		for (var i = 0; i < c; ++i)
		{
			if (allTheData[i].symbol == lastSelected)
			{
				found = true;
				break;
			}
		}
		
		if (!found)
		{
			// the item we have selected is gone. select the first one
			clickonrowimp ($('tbody').firstChild);
		}
		else
		{
			moveSelectionToTag (lastSelected);
		}
	}
}

function generateSymbolString (object)
{
		return object.symbol;
}

function generateSymbolStringFromStrings (symbol, exchange)
{
		return symbol;
}

function getStockData()
{
	var c = allTheData.length;

	if (c > 0)
	{
		var symbols = [];
		for (var i = 0; i < c; ++i) {
			symbols[symbols.length] = generateSymbolString(allTheData[i]);
		}

		fetchStockData (quotes_callback, symbols);

		//
		// ouch should only do this if the day is not close, otherwise
		// there is no need to update.  get this info in the feed somewhow
		// MB: well, intraday changes are reflected up to 1w.
		if (currentSelection != null && (currentChartMode == '1d' || currentChartMode == '1w'))
		{
			if (lastChartRequest != null)
				lastChartRequest.abort();
			var tag = currentSelection.getAttribute("tag");
			var exchange = currentSelection.getAttribute("stock_exchange");
			lastChartRequest = fetchChartData (generateSymbolStringFromStrings(tag, exchange), currentChartMode, chart_callback);
		}
	}
}

function changeFontOfElement(element, width)
{
    var elementWidth = 99999;

    while (elementWidth > width) {

        var style = document.defaultView.getComputedStyle(element,'');
        		
		if (!style)
		{
			break;
		}
		
        var fontSize = parseInt(style.getPropertyValue("font-size"));

        elementWidth = parseInt(style.getPropertyValue("width"));
        if (elementWidth > width)
        {
    
			element.style.fontSize = (fontSize - 1) + "px";
		
			style = document.defaultView.getComputedStyle(element,'');
			elementWidth = parseInt(style.getPropertyValue("width"));
		}
		else
		{
			break;
		}
    }
}

var img = new Image();
img.src = "Images/selection-middle.png";
img.src = "Images/yahoo_hover.png";
img.src = "Images/yahoo_down.png";

function moveSelectionToTag (tag)
{
	var index = 0;
	var node;
	for (node = $('tbody').firstChild; node != null; node = node.nextSibling, ++index) {
		if (node.getAttribute("tag") == tag) {
			break;
		}
	}
	if (node == null) {index = 0}

	var offset=1;

	var folder = kColorthememapInfo[getColorThemeIdx()].folder;
	switch (index)
	{
		case 0:
			// note: selection here is a global variable. The global scope is the window, thus it is window.selection, a dom element (id of a document element).
			selection.src = folder + "/selection-first.png";
			offset = 0;
			break;
		case allTheData.length - 1:
			selection.src = folder + "/selection-last.png";
			break;
			
		default:
			selection.src = folder + "/selection-middle.png";
			break;
	}
	
	// top is 7px;
	// had to add an offset. The top is at 7px, but the others needed
	// to go down by one pixel
	selection.style.top = (25*index+7+offset).toString() + "px";
	selection.style.display = "block";
}

function clickonrowimp (row)
{
	var selection = $('selection');
			
	currentSelection = row; // global
	
	moveSelectionToTag (row.getAttribute("tag"));
		
	getChartForCurrentMode ();
}

function setupChartAnimation (hiding)
{
	var chartDiv = $('chart');
	var timeNow = (new Date).getTime();
	var multiplier = (event.shiftKey ? 10 : 1); // enable slo-mo
	var startingSize = parseInt(chartDiv.clientHeight,10);

	resizeAnimation.element = chartDiv;
	if (resizeAnimation.timer != null) // it is moving... change to new size
	{
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
		resizeAnimation.positionFrom = resizeAnimation.positionNow;
	}
	else
	{
		resizeAnimation.duration = 250 * multiplier;
		resizeAnimation.positionFrom = startingSize;
	}
	
	if (window.widget && !hiding)
	{
		window.resizeTo (213, calculateWidgetHeight());
	}
	resizeAnimation.positionTo = hiding ? 0 : 80;
	resizeAnimation.startTime = timeNow - 13; // set it back one frame.
	resizeAnimation.onfinished = hiding ? animFinished : null;
	
	resizeAnimation.element.style.height = startingSize;
	resizeAnimation.timer = setInterval ("animate();", 13);
	animate();
}

function clickonrow (event, row)
{
	var oldSelection = currentSelection;
	
	if (currentSelection != null && row == currentSelection)
	{
		$('selection').style.display = "none";
		currentSelection = null;
		if (window.widget) {
			widget.setPreferenceForKey ("!!NONE!!", createKey("selection"));
		}
	
		setupChartAnimation (true);
		showingCharts = false;
		if (lastChartRequest != null)
		{
			lastChartRequest.abort();
			lastChartRequest = null;
		}
	}
	else
	{
		clickonrowimp(row);
		
		if (window.widget && oldSelection != currentSelection)
		{
			//write out the selection
			widget.setPreferenceForKey (row.getAttribute("tag"), createKey("selection"));
		}
		
		if (oldSelection == null)
		{
			showingCharts = true;
			setupChartAnimation (false);
		}
	}
}

function updateChangeSpans ()
{
	var c = symbolData.length;
	var change_span;
	var size;
	var type;
	
	if (getShowPercent())
	{
		size = "12px";
		type = "_percent";
	}
	else
	{
		size = "13px";
		type = "_change";
	}
	
	for (var i = 0; i < c; ++i)
	{
		change_span = $(symbolData[i].symbol+type);
		change_span.style.fontSize = size;
		changeFontOfElement(change_span, 41);
	}
}


// Preference Color

function clickOnColor(event, coloridx)
{
	setColorThemeIdx(coloridx);
	updateColorThemeUI(coloridx);

	event.stopPropagation();
	event.preventDefault();
}

function positioncheck (coloridx) {
	var obj = kColorthememapInfo[coloridx];
	if (obj == null) {
		kColorthememapInfo[0];
	}

	var imgelem = $("checkimg");
	imgelem.style.top = obj.top;
	imgelem.style.left = obj.left;
}

function updateColorThemeUI(coloridx)
{
	positioncheck(coloridx);

	var folder = kColorthememapInfo[coloridx].folder;

	["#tableTop", ".tableRowLight", ".tableRowDark", ".tableBottomLight", ".tableBottomDark", "#chart", "#footer", "#inner-list"].forEach(
		function(e) {cssRuleChanger.replace(e, "background", /Images(\.[a-zA-Z]+)?/, folder);}
	);


	if (currentSelection != null) {
		moveSelectionToTag (currentSelection.getAttribute("tag"));
	}


	addButton.changeImageFolder(folder);
	removeButton.changeImageFolder(folder);
	renameButton.changeImageFolder(folder);

	img.src = folder + "/selection-middle.png";
	img.src = folder + "/yahoo_hover.png";
	img.src = folder + "/yahoo_down.png";
}


function handleRowClick (event)
{
	if (event.altKey || event.shiftKey || event.metaKey) {
		showSortedChanged(event);
	}
	else {
		showAsPercentChanged(event);
	}
}


// Preference Sort

function showSortedChanged (event)
{
	clickonShowSorted(event);
	event.stopPropagation();
	event.preventDefault();
}

function updateSortCheckbox (show_sorted)
{
	var checkbox = $('sortcheck');	
	checkbox.checked = show_sorted;
}

function clickonShowSorted (event)
{
	var showSorted = getShowSorted();

	var newVal = !showSorted;
	// set the preference
	setShowSorted (newVal);
	updateShowSortedUI(newVal);

	// stop proagation otherwise the clickonrow handler would be called
	event.stopPropagation();
}

function updateShowSortedUI (newVal)
{
	if (newVal) {
		sortSymbolRows();
	}
	else {
		unsortSymbolRows();
		// updateSymbolRowsAndSelection();
	}

	updateSortCheckbox(newVal);
}

function sortSymbolRows()
{
	// sort by performance
	var container = $('tbody');	// container of rows

	var sortarray = new Array();
	for (var node = container.firstChild; node != null; node = node.nextSibling) {
		sortarray[sortarray.length] = node;
	}
	sortarray.sort(symbolSortFunction);
	removeAllChildren(container);
	for (var i = 0; i < sortarray.length; i++) {
		container.appendChild(sortarray[i]);
	}

	if (currentSelection != null) {
		moveSelectionToTag (currentSelection.getAttribute("tag"));
	}
}

function unsortSymbolRows()
{
	// sort by performance
	var container = $('tbody');	// container of rows

	var sortarray = new Array();
	for (var node = container.firstChild; node != null; node = node.nextSibling) {
		var i;
		for (i = 0; i < allTheData.length; i++) {
			if (node.getAttribute("tag") == allTheData[i].symbol) { break; }
		}
		sortarray[i] = node;
	}
	removeAllChildren(container);
	for (var i = 0; i < sortarray.length; i++) {
		container.appendChild(sortarray[i]);
	}

	if (currentSelection != null) {
		moveSelectionToTag (currentSelection.getAttribute("tag"));
	}
}


// Preference Percent/Absolute

function showAsPercentChanged (event)
{
	clickonShowAsPercent(event);
	event.stopPropagation();
	event.preventDefault();
}

function updatePercentCheckbox (showPercent)
{
	var checkbox = $('percentcheck');	
	checkbox.checked = showPercent;
}

function clickonShowAsPercent (event)
{
	var showPercent = getShowPercent();

	var newVal = !showPercent;
	// set the preference
	setShowPercent (newVal);
	updateShowPercentUI(newVal);

	// stop proagation otherwise the clickonrow handler would be called
	event.stopPropagation();
}

function updateShowPercentUI (showPercent) {
	var c = symbolData.length;
	var i;
	var change;
	var percent;
	
	if (!showPercent) // show change
	{
		for (i = 0; i < c; ++i)
		{
			change = $(symbolData[i].symbol+"_change");
			percent = $(symbolData[i].symbol+"_percent");
			
			percent.setAttribute ('class', 'change hidden');
			change.setAttribute ('class', 'change');
			
		}
	}
	else // show percent
	{
		for (i = 0; i < c; ++i)
		{

			change = $(symbolData[i].symbol+"_change");
			percent = $(symbolData[i].symbol+"_percent");

			percent.setAttribute ('class', 'change');
			change.setAttribute ('class', 'change hidden');
		}
	}
	
	updateChangeSpans();
	updatePercentCheckbox(showPercent);
}




function clickedOnSymbol (symbol, exchange)
{
	if (window.widget)
	{
		var url = 'http://finance.yahoo.com/q?s=' + symbol;
		widget.openURL(url);
	}
}

function onshow ()
{
	if (timer == null)
	{
		getStockData(); // reload we were just shown
		timer = setInterval('getStockData();', kRefreshPeriod);
	}
	else
	{
		updateStatusText(); // at least update them on our status
	}
}

function onhide ()
{
	if (timer != null)
	{
		// we were hidden clear the timer.
		clearInterval(timer);
		timer = null;
	}
}

document.addEventListener("keypress", keyPressed, true);


function keyPressed(e) {
	
	var handled = true;
	var selection = currentSelection;
	
	if (selection != null)
	{
		switch (e.charCode)
		{
			case kKeyLeftArrow:
				if (showingCharts)
				{
					currentChartMode = nextChartMode(currentChartMode, -1);
					setupChartController (currentChartMode);
					getChartForCurrentMode();
				}
				break;
			case kKeyRightArrow:
				if (showingCharts)
				{
					currentChartMode = nextChartMode(currentChartMode, +1);
					setupChartController (currentChartMode);
					getChartForCurrentMode();
				}
				break;
			case kKeyUpArrow: // up
				selection = selection.previousSibling;
				if (selection == null)
				{
					selection = $('tbody').lastChild;
				}
				clickonrow (e, selection);
				break;
				
			case kKeyDownArrow: // down
				selection = selection.nextSibling;
				if (selection == null)
				{
					selection = $('tbody').firstChild;
				}
				clickonrow (e, selection);
				break;
				
			default:
				handled = false;
				break;
		}
		
		if (handled)
		{
			e.stopPropagation();
			e.preventDefault();
		}
	}
}

function setupMainTable(addSymbolsToBackside)
{
	var container = $('tbody');
	removeAllChildren(container);

	if (addSymbolsToBackside) {
		var innerList = $('inner-list');
		innerList.innerHTML = "";
	}

	var sortedData = allTheData.clone();
	if (getShowSorted()) {
		sortedData.sort(symbolSortFunction);
	}

	var c = sortedData.length;
	for (var i=0; i<c; ++i)
	{
		var data = sortedData[i];
		var row = createRow (data);
		container.appendChild (row);
		if (addSymbolsToBackside) {
			addsymbol (data.symbol, data.name);
		}
	}

	//set the bottom of table to correct class
	if (c < 2) {c = 2}
	$('tableBottom').setAttribute ("class", (c%2) != 0 ? "tableBottomDark" : "tableBottomLight");
	
	// fill in the backgorund
	container = $('tableContainer');
	removeAllChildren(container);

	c = c - 2;
	var light = true;
	for (var i = 0; i < c; ++i)
	{
		var div = document.createElement ('div');
		div.setAttribute  ("class", light ? "tableRowLight" : "tableRowDark");
		container.appendChild (div);
		light = !light;
	}
}


function loadPreferences() {
	if (window.widget)
	{
		try {
			selectedSymbol = getPreferenceForKey("selection", false, null);
			var symbols = getPreferenceForKey ("symbols", true, null);
			var newAllData = new Array;
			
			symbols = eval(symbols);
			if (!symbols || !symbols.length) {
				return;
			}

			var c = symbols.length;
			
			if (c == 0)
			{
				allTheData = new Array; // nothing to see move along
			}
			else
			{
				for (var i = 0; i < c; ++i)
				{
					var data = symbols[i];
					
					var exchange = data.exchange === undefined ? '' : data.exchange;
					var display = data.display === undefined ? '' : data.display;
					newAllData[newAllData.length] = {symbol:data.symbol, exchange:exchange, display:display, name:data.name, lasttrade:0, change:0, pctchange:0};
				}
				
				allTheData = newAllData;
			}
			
			currentChartMode = getPreferenceForKey("chartmode", false, null);
			if (currentChartMode == null) {currentChartMode='3m'}
		
		} catch(ex)
		{
			alert(ex.name + ". " + ex.message);
		}
	}
}

function setupUI()
{
	// add all of our stocks to the widget
	setupMainTable (true);
	setupChartController (currentChartMode);

	var header = $('tbody');
	currentSelection = header.firstChild;
	if (selectedSymbol != null)
	{
		if (selectedSymbol == '!!NONE!!')
		{
			$('selection').style.display = "none";
			currentSelection = null;
			showingCharts = false;
			$('chart').style.height = "0";
		}
		else
		{
			for (var child = header.firstChild; child != null; child = child.nextSibling)
			{
				if (child.getAttribute("tag") == selectedSymbol)
				{
					// no need to do anything if the first item is the one selected.
					if (currentSelection != child)
					{
						clickonrowimp (child);
					}
					break;
				}
			}
		}
	}
	else
	{
		// try to select apple.
		for (var child = header.firstChild; child != null; child = child.nextSibling)
		{
			if (child.getAttribute("tag") == 'AAPL')
			{
				// no need to do anything if the first item is the one selected.
				if (currentSelection != child)
				{
					clickonrowimp (child);
				}
				break;
			}
		}
	}

	if (showingCharts) {
	 	getChartForCurrentMode();
	}
	
	if (getShowPercent()) {
		$('percentcheck').checked = true;
	}
	if (getShowSorted()) {
		$('sortcheck').checked = true;
	}

	if (window.widget && (allTheData.length != 6 || !showingCharts)) {
		var h = calculateWidgetHeight();
		window.resizeTo (213, h);
	}
}

function setupWidget()
{
	selectedSymbol = null;

	loadPreferences();
	setupUI();
	
	// front side strings
	// this will happen every time it is shown.
	//$('retrieving').innerText = getLocalizedString('Retrieving Data…');
	
	// backside strings
	$('quoteslabel').innerText = getLocalizedString('Quotes:');
	$('percenttext').innerHTML = getLocalizedString('Show change as a percentage');
	$('sortoptiontext').innerHTML = getLocalizedString('Sort by performance');

	$('colorthemelabel').innerHTML = getLocalizedString('Color Theme')+":";
	$('versionlabel').innerHTML = getLocalizedString('Version')+" "+kVersion;


	// $('tosLink').innerText = getLocalizedString('Terms of Service');
	
	// Info button
	new AppleInfoButton($('flip'), $('front'),
						"white", "white", showbackside);
	
	
	// Done button
	var doneButton = new AppleGlassButton($('done'),
										  getLocalizedString('Done'), selectDone);
	doneButton.textElement.style.textAlign = "center";
	doneButton.textElement.style.width = "47px";

	var folder = kColorthememapInfo[getColorThemeIdx()].folder;
	addButton = new MabaAddImageButton(folder);
	removeButton = new MabaRemoveImageButton(folder);
	renameButton = new MabaRenameImageButton(folder);
	symbolnameEditEnable(false);

	updateColorThemeUI(getColorThemeIdx(true));

	checkForUpdate(versionCheckCallback, kVersion);

	onshow();
}

function versionCheckCallback(newVersion)
{
	if (newVersion != null) {
		$('newversionlabel').innerHTML = getLocalizedString('Version')+" "+newVersion+" "+getLocalizedString('available');
		$('newversionlabel').style.display = "block";

		$('logo-maba').style.display = "none";
	}
}

function symbolnameEditEnable(flag)
{
	removeButton.setEnabled(flag);
	renameButton.setEnabled(flag);
	var symbolname_input = $('symbolname');
	symbolname_input.disabled = !flag;
	if (flag == false) {
		symbolname_input.style.opacity = 0.2;
		symbolname_input.value = "";
	}
	else {
		symbolname_input.style.opacity = 1.0;
	}
}

function onsync() {
	loadPreferences();
	setupUI();
	updateShowPercentUI(getShowPercent(true));
	updateShowSortedUI(getShowSorted(true));
	updateColorThemeUI(getColorThemeIdx(true));
	onshow();
}

// add the onhide and onshow callbacks
if (window.widget)
{
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onremove = onremove;
	widget.onsync = onsync;
}

var selectedRow=null;
function clickonbackrow(event, row)
{
	if (allTheData.length > 1) {
		symbolnameEditEnable(true);
	}

	if (selectedRow != row)
	{
		if (selectedRow != null) {
			selectedRow.setAttribute("class", "row");
		}
		selectedRow = row;
		
		row.setAttribute ("class", "row select");

		var idx = findIndexOfChild (selectedRow);
		$("symbolname").value = getPrettySymbol(allTheData[idx]);
	}	
	
	if (event)
	{
		event.stopPropagation();
		event.preventDefault();
	}
}

function backsideKeyPressed(event)
{
	switch (event.keyCode)
	{
		case kKeyUpArrow: // up
			backsideCursorPressed(false);
			break;
			
		case kKeyDownArrow: // down
			backsideCursorPressed(true);
			break;
	}
	
	if (event)
	{
		event.stopPropagation();
		event.preventDefault();
	}
}

function backsideCursorPressed (isCursorDown)
{
 	if (allTheData.length < 2) {return}
 	if (selectedRow == null) {return}

	var newSelection = null;
	var from_index = null;
	var to_index = null;
	var innerList = $('inner-list');

	newSelection = isCursorDown ? selectedRow.nextSibling : selectedRow.previousSibling;
	from_index = findIndexOfChild (selectedRow);

	if (newSelection == null) {return}
//		newSelection = isCursorDown ? innerList.firstChild : innerList.lastChild;

	to_index = findIndexOfChild (newSelection);
	if (from_index != null && (from_index != to_index)) {
		allTheData.swap(from_index, to_index);

		var from_child = innerList.childNodes[from_index];
		var to_child = innerList.childNodes[to_index];
		if (from_index > to_index)
			DOMNode_swapNode(to_child, from_child);
		else
			DOMNode_swapNode(from_child, to_child);

		newSelection = from_child;

		anythingChangedOnBackside = true;
	}

	clickonbackrow(null, newSelection);
}

function symbolFocus(event)
{
	document.removeEventListener("keypress", backsideKeyPressed, true);
}

function symbolBlur(event)
{
	document.addEventListener("keypress", backsideKeyPressed, true);
}

var validateTimerData = null;
var lastValidEntry = null;

function symbolChanged (event)
{	
	var symbol = $('symbolinput').value;
		
	if (symbol != null && symbol.length > 0 && addButton.isButtonClicked())
	{
		var request = validateSymbol (validateSymbolCallback, symbol);
		
		cancelValidateTimer();
		lastValidEntry = null;

		var validate = $('validate');
		validate.innerText = getLocalizedString('Validating');
		validate.style.display = "block";
		
		validateTimerData = {timer:setInterval('validateTimer();', 500), pos:0, request:request};
	}
}


function cancelValidateTimer ()
{
	if (validateTimerData != null)
	{
		validateTimerData.request.abort();
		clearInterval(validateTimerData.timer);
		validateTimerData = null;
		$('validate').style.display="none";
	}
}

function validateTimer ()
{
	var validate = $('validate');
	
	// position goes 0 -> 3 and then resets
	validateTimerData.pos++;
	
	if (validateTimerData.pos > 3)
	{
		validateTimerData.pos = 0;
	}
	
	var text = getLocalizedString('Validating');
	for (var i = 0; i < validateTimerData.pos; ++i)
		text+= '.';
	
	validate.innerText = text;
}

function validateSymbolCallback (object)
{
	var menu = null;
	var inputChanged = false;
	
	cancelValidateTimer();
	
	if (isShowingFront) {return}
	
	if (window.widget) {
		menu = widget.createMenu();
	}

	if (object.error)
	{
		if (menu != null)
		{
			menu.addMenuItem (getLocalizedString("Failed to validate symbol"));
			menu.setMenuItemEnabledAtIndex (0, false);	
		}
		alert ('Validating symbol failed, error=' + object.errorString);
	}
	else if (object.symbols.length < 1)
	{
		if (menu != null)
		{
			menu.addMenuItem (getLocalizedString("No matching symbols"));
			menu.setMenuItemEnabledAtIndex (0, false);	

			// Add Menu item "Add anyway"
			menu.addSeparatorMenuItem();
			menu.addMenuItem (getLocalizedString("Add Symbol without Validation!"));
			menu.setMenuItemTagAtIndex (2, kMenuAddAnywayMarker);
		}
	}
	else
	{
		if (menu == null || object.symbols.length == 1) // there is only one, just put it in
		{
			menu = null;

			lastValidEntry = object.symbols[0];
			$('symbolinput').value = lastValidEntry.symbol;
			inputChanged = true;
		}
		else
		{
			if (menu != null)
			{
				var c = object.symbols.length;
				var a = object.symbols;
				var maxLength = 0;
							
				var lastExchange = a[0].exchange;
				var lastIndex = 0;
				for (var i = 0; i < c; ++i)
				{
					var str = a[i].symbol;
					var name = a[i].name;
					var exchange = a[i].exchange;
					
					if (name != null || (exchange !== undefined && exchange != null))
					{
						str += " - "	;			
					
						if (name != null) {
							str += name;
						}
						
						if (exchange !== undefined && exchange != null)
						{
							if (name != null)
								str += " (";
							str += exchange;
							if (name != null)
								str += ")";
						}
					}
					
					if (exchange !== undefined && exchange != null && exchange != lastExchange)
					{
						menu.addSeparatorMenuItem();
						lastIndex++;
						lastExchange = exchange;
					}
					menu.addMenuItem (str);
					menu.setMenuItemTagAtIndex (lastIndex, i+1); // switch to one based
					lastIndex++;
				}
				
				// Add Menu item "Add anyway"
				menu.addSeparatorMenuItem();
                lastIndex++;
				menu.addMenuItem (getLocalizedString("Add Symbol without Validation!"));
				menu.setMenuItemTagAtIndex (lastIndex, kMenuAddAnywayMarker);
			}
		}
	}
	
	if (menu != null)
	{
		var selectedItem = menu.popup (15, 43);
		
		if (selectedItem >= 0)
		{
			var idx = menu.getMenuItemTagAtIndex(selectedItem);
			if (idx == kMenuAddAnywayMarker) {
				lastValidEntry = new Object();
				lastValidEntry.symbol = $('symbolinput').value;
				lastValidEntry.name = "Unknown";
			}
			else {
				lastValidEntry = object.symbols[idx-1];
				$('symbolinput').value = lastValidEntry.symbol;
			}
			inputChanged = true;
		}	
	}
	
	if (addButton.isButtonClicked() && inputChanged)
	{
		addOrSelectItem ();	
	}
	
	addButton.setButtonClicked(false);
}

function symbolAlreadyInSet(symbol)
{
	var c = allTheData.length;
	
	for (var i = 0; i < c; ++i)
	{
		if (allTheData[i].symbol == symbol) {
			return i;
		}
	}

	return -1;
}

function addOrSelectItem ()
{
	var index = symbolAlreadyInSet(lastValidEntry.symbol)
	if (index < 0)
	{
		// make sure we have the correct number of items
		if (allTheData.length < kMaxSymbols)
		{
			var row = addsymbol (lastValidEntry.symbol, lastValidEntry.name);
		
			allTheData[allTheData.length] = {symbol: lastValidEntry.symbol, display: lastValidEntry.symbol, exchange:lastValidEntry.exchange, name:lastValidEntry.name, lasttrade:0, change:0, pctchange:0};
			anythingChangedOnBackside = true;
			
			clickonbackrow (null, row);
		}
	}
	else
	{
		// select the item that is already there.
		var row = $('inner-list').firstChild;
		for (var i = 0; i < index; ++i)
			row = row.nextSibling;
			
		if (row != null) // just to be safe, should never happen
		{
			clickonbackrow (null, row);
		}
	}

	addButton.setButtonClicked(false);
}



function findIndexOfChild (child)
{
	var node = child.parentNode;
	var i = 0;
	for (node = node.firstChild; node != null; node = node.nextSibling, ++i) {
		if (node == child)
			return i;
	}
	return -1;
}

function removeAllChildren (parent)
{
	while (parent.hasChildNodes())
		parent.removeChild(parent.firstChild);
}


function removeButtonClicked ()
{
	if (selectedRow != null)
	{
		var index = findIndexOfChild (selectedRow);
		var parentNode = selectedRow.parentNode;
		
		symbolData.splice (index, 1);
		allTheData.splice (index, 1);
		parentNode.removeChild(selectedRow);

		selectedRow = null;
		if (allTheData.length >= 1)
		{
			if (index >= allTheData.length)
				index = allTheData.length-1;
			
			var nextSelection = parentNode.firstChild;
			for (var i=0; i<index;++i)
				nextSelection = nextSelection.nextSibling;
			
			if (nextSelection != null)
				clickonbackrow (null, nextSelection);
		}
		else
		{
			symbolnameEditEnable(false);
		}
		anythingChangedOnBackside = true;
	}
}

function renameButtonClicked ()
{
	if (selectedRow != null)
	{
		var index = findIndexOfChild (selectedRow);

		var newname = $("symbolname").value;
		if (newname != '') {
			allTheData[index].display = newname;
			$("symbolname").blur();
			renameButton.pulseButton();
			anythingChangedOnBackside = true;
		}
	}
}


function addsymbol (symbol, name)
{
	var innerList = $('inner-list');
	
	var row = document.createElement('div');
	row.setAttribute("class", "row");
	row.setAttribute("onclick", "clickonbackrow(event, this);");
	
	var span = document.createElement('span');
	span.setAttribute ("class", "col1");
	span.innerText = symbol;
	row.appendChild(span);
	
	span = document.createElement('span');
	span.setAttribute ("class", "col2");
	span.innerText = convertHtmlEntities(name);
	row.appendChild(span);
	
	innerList.appendChild(row);
	
	selectAllInSymbolTextField();

	return row;
}

function convertHtmlEntities (name) {
	// convert html entities to regular symbols
	return name.replace(/&amp;/g, "&");
}


function selectAllInSymbolTextField() 
{
	var input = $("symbolinput");
	input.blur();
	input.focus();
	input.select();
}

function calculateWidgetHeight() {
	var height = 34 + // table top
	             29 + // table bottom
	             35;  // footer
	
	if (showingCharts)
		height += 80;
		
	var c = allTheData.length - 2;
	
	if (c > 0)
		height += (c * 25); // 25 row height
	
	return height;
}

function onremove ()
{
	// remove all the pref pref keys here
	widget.setPreferenceForKey (null, createKey("symbols"));
	widget.setPreferenceForKey (null, createKey("selection"));
	widget.setPreferenceForKey (null, createKey("chartmode"));

	widget.setPreferenceForKey (null, createKey("colortheme"));
	widget.setPreferenceForKey (null, createKey("show-percent"));
	widget.setPreferenceForKey (null, createKey("show-sorted"));
}

function createKey (key)
{
	return widget.identifier + "-" + key
}

function setPreferenceForKey (pref, key)
{
	// set both the per widget pref and the global
	widget.setPreferenceForKey(pref, createKey(key));
	widget.setPreferenceForKey(pref, key);
}

function getPreferenceForKey (key, global, defval)
{
	// first check to see if we have a per instance one
	var pref = widget.preferenceForKey(createKey(key));
	
	if (pref == undefined || pref == null && global)
	{
		// now check the global one
		pref = widget.preferenceForKey(key);
	}

	return (pref == undefined || pref == null) ? defval : pref;
}

function createAllDataJSString ()
{
	var str = "["
	var c = allTheData.length;
	
	for (var i = 0; i < c; ++i)
	{
		var data = allTheData[i];
		if (i != 0)
			str += ",";
		// make sure the name does not have any single quotes in it
		var name = data.name.replace(/\'/g, "\\'");
		str += "{symbol:'" + data.symbol + "',exchange:'" + data.exchange + "',display: '" + data.display + "',name:'" + name + "'}";
	}
	
	str += "];";
	
	return str;
}

var resizeAnimation = {startTime:0, duration:250, positionFrom:0, positionTo:0, positionNow:0, timer:null, element:null, onfinished:null};


function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function animate () {
	var T;
	var ease;
	var time  = (new Date).getTime();
	var yLoc;
	var frame;
		
	T = limit_3(time-resizeAnimation.startTime, 0, resizeAnimation.duration);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / resizeAnimation.duration));

	if (T >= resizeAnimation.duration)
	{
		yLoc = resizeAnimation.positionTo;
		clearInterval (resizeAnimation.timer);
		resizeAnimation.timer = null;
		
		if (resizeAnimation.onfinished)
			setTimeout ("resizeAnimation.onfinished();", 0); // call after the last frame is drawn
	}
	else
		yLoc = computeNextFloat(resizeAnimation.positionFrom, resizeAnimation.positionTo, ease);
		
	// convert to a integer, not sure if this is the best way
	resizeAnimation.positionNow = parseInt(yLoc);
	resizeAnimation.element.style.height = resizeAnimation.positionNow + "px";
}

function animFinished()
{
	if (window.widget)
	{
		window.resizeTo (213, calculateWidgetHeight());	
	}
}

var currentChartSelect = null;
var lastChartRequest = null;
function dayclick(event, td, tag)
{
	if (td == currentChartSelect && td != null) return;
	
	if (currentChartSelect != null)
		currentChartSelect.setAttribute ("class", "");
	
	if (currentChartSelect != td)
	{
		td.setAttribute ("class", "selected");
		currentChartSelect = td;
	
		currentChartMode = tag;
		getChartForCurrentMode();
		
		if (window.widget)
			widget.setPreferenceForKey(tag, createKey("chartmode"));
	}
}

function getChartForCurrentMode ()
{
	if (lastChartRequest != null)
		lastChartRequest.abort();
	
	enableChart(false, false);
	var tag = currentSelection.getAttribute("tag");
	var exchange = currentSelection.getAttribute("stock_exchange");
	lastChartRequest = fetchChartData (generateSymbolStringFromStrings(tag, exchange), currentChartMode, chart_callback);
}

var horizonalLines = new Image();
horizonalLines.src = 'Images/stocks_chartgradient.png';

function addElementToVerticalAxes (vaxes, showPrecision, value)
{
	var div = document.createElement('div');
	if (showPrecision)
		div.innerText = value.toFixed(2).toString();
	else
		div.innerText = Math.round(value);
	vaxes.appendChild (div);
}

function addVerticalAxes (min, max)
{
	var vaxes = $('vertical-axes');
	removeAllChildren (vaxes);
		
	var unitdelta = (max - min) * 0.375; // 3/8 for the middle pieces
	var showPrecision = unitdelta <= 1;
	
	// top
	addElementToVerticalAxes (vaxes, showPrecision, max);
	// top middle
	addElementToVerticalAxes (vaxes, showPrecision, max - unitdelta);
	// bottom middle
	addElementToVerticalAxes (vaxes, showPrecision, min + unitdelta);
	//bottom
	addElementToVerticalAxes (vaxes, showPrecision, min);
}

function chart_callback (obj)
{
	if (!obj.error)
	{
		var data = obj.data;
		gChartData = data;
		var c = data.length;

		if (obj.data.length > 0)
		{
		
			
			enableChart(true, true);			
			
			
//
// calculate min/max
//
			var context = $('chart-canvas').getContext('2d');
			context.clearRect(0, 0, kChartCanvasWidth, kChartCanvasHeight);

			var min = data[0].close;
			var max = min;
			
			for (var i = 0; i < c; ++i)
			{
				var close = data[i].close;
				if (close > max)
					max = close;
				else if (close < min)
					min = close;
			}

			//
			// setup the veritcal axes
			//
			addVerticalAxes (min, max);
			setupHorizontalAxes (obj, currentChartMode);	
						
			// pad 1/16 of the data
			// turn padding off.
			/*var delta = (max - min)  / 16;
			max = max + delta;
			min = min - delta;
			*/
			var xy = createXYList(min, max, currentChartMode, obj);
			gXY = xy;
			c = xy.length;

//
// now clip an draw
//
			
//
// first clip
//
			
			if (c < 2) // just draw the background
				context.drawImage (horizonalLines, 0, 0);
			else
			{
				context.beginPath();
				context.save();
				context.moveTo(0, kChartCanvasHeight);
				context.lineTo(0, xy[0][1]);
				var val;
				for (var i = 0; i < c; ++i)
				{
					val = xy[i];
					context.lineTo (val[0],val[1]);
				}
				context.lineTo (val[0], kChartCanvasHeight);
				context.clip();
				
				context.drawImage (horizonalLines, 0, 0);
				
				context.restore();

//
// then render line
//
				context.beginPath();
				context.lineWidth = 2.0;
				context.strokeStyle = "rgb(255, 255, 255)";
				
				context.moveTo(0, xy[0][1]);
				for (var i = 0; i < c; ++i)
				{
					val = xy[i];
					context.lineTo (val[0],val[1]);
				}
				context.stroke();
			}
		}
		else
		{
			$('retrieving').innerText = getLocalizedString('No chart data');
		}
	}
	else
	{
		enableChart(false, false);
		$('retrieving').innerText = getLocalizedString('Error retrieving chart');
		alert ('fetching chart failed: ' + obj.errorString);
	}
}

// workaround for canvas not rendering after display change.
function enableChart (enable, useCanvas)
{
	var verticalaxes = $('vertical-axes');
	var haxes = $('horizontal-axes');
	var retrieving = $('retrieving');
	var chartimage = $('chart-image');

	if (enable)
	{
		if (useCanvas) {
			verticalaxes.style.display = 'block';
			haxes.style.display = 'block';
		}
		else
			chartimage.style.display='block';
		
		retrieving.style.display='none';
	}
	else
	{
		retrieving.innerText = getLocalizedString('Retrieving Data…');
		retrieving.style.display='block';

		verticalaxes.style.display = 'none';
		haxes.style.display = 'none';

		chartimage.style.display='none';

		// ick ick ick, clear the canvas
		$('chart-canvas').getContext('2d').clearRect (0, 0, kChartCanvasWidth, kChartCanvasHeight);
	}
}

function nextChartMode (mode, incr)
{
	var c = chartModes.length;
	
	for (var i = 1; i < c; ++i)
	{
		var m = chartModes[i];
		if (m == mode)
		{
			return chartModes[(i+incr)%c];
		}
	}
	return chartModes[(c+incr)%c];
}

function setupChartController (mode)
{
	var c = chartModes.length;
	
	for (var i = 0; i < c; ++i)
	{
		var m = chartModes[i];
		var div = $(m+'text');
		div.innerHTML = getLocalizedString(m);
		
		if (m == mode)
		{
			if (currentChartSelect != null)
				currentChartSelect.setAttribute ("class", "");
			
			currentChartSelect = div.parentNode;
			currentChartSelect.setAttribute ("class", "selected");
		}
	}
}



function setupHorizontalAxes (chartObj, mode)
{
	var chartData = chartObj.data;
	var xaxes = document.getElementById('horizontal-axes');

	removeAllChildren (xaxes);

	var labelArray = [];
	switch (mode)
	{
		case "1d": labelArray = oneDayHorizontalLabels(chartObj.marketopen, chartObj.marketclose); break;			
		case "1w": labelArray = dayLabelsForHorizontalAxes(chartObj, 1, true); break;
		case "1m": labelArray = dayLabelsForHorizontalAxes(chartObj, 7, true); break;
		case "3m": labelArray = monthLabelsWithInterval(chartData, 1); break;
		case "6m": labelArray = monthLabelsWithInterval(chartData, 1); break;
		case "1y": labelArray = monthLabelsWithInterval(chartData, 2); break;
		case "2y": labelArray = monthLabelsWithInterval(chartData, 4); break;
	}

	var context = document.getElementById('chart-canvas').getContext('2d');
	context.beginPath();
	context.save();
	context.lineWidth = .25;
	context.strokeStyle = "rgb(200,200,200)";
	// context.strokeStyle = "rgb(255, 255, 255)";
	
	var hasDrawnLineAtRightEdge = false;
			
	for(var index = 0; index < labelArray.length; index++)
	{
		var labelPositionPair = labelArray[index];

		var label = labelPositionPair[0];
		var position = labelPositionPair[1];

		if(position < 0) //negative means evenly space the labels
			position = (labelArray.length-1-index)/(labelArray.length-1);

		var div = document.createElement('div');
		div.innerText = label;
		div.setAttribute ("class", "xaxes");
		xaxes.appendChild (div);

		div.style.left = position*kChartCanvasWidth - (div.clientWidth/2) + kOffsetBtCanvasAndXAxes + "px";
		
		//draw a vertical line at that point
		context.moveTo(position*kChartCanvasWidth, kChartCanvasHeight);
		context.lineTo(position*kChartCanvasWidth, 0);
		context.stroke();
		
		if(position == 1)
			hasDrawnLineAtRightEdge = true;
	}	

	context.strokeStyle = "rgb(255, 255, 255)";
	context.lineWidth = .25;

		if(!hasDrawnLineAtRightEdge)
		{
			//draw the bottom line
			context.moveTo(kChartCanvasWidth, 0);
			context.lineTo(kChartCanvasWidth, kChartCanvasHeight);
			context.stroke();			
		}
		
		//draw the bottom line
		context.moveTo(0, kChartCanvasHeight);
		context.lineTo(kChartCanvasWidth, kChartCanvasHeight);
		context.stroke();
}

function oneDayHorizontalLabels (marketopen, marketclose)
{
	var labelArray = [];
    var openHourExact = marketopen.getHours() + marketopen.getMinutes() / 60.0;
    var openHour = Math.ceil(openHourExact);
    var closeHourExact = marketclose.getHours() + marketclose.getMinutes() / 60.0;
    var closeHour = Math.floor(closeHourExact);
    var hourRange = closeHour - openHour;

    var labelIndex = 0;
    var hourLabels = [];
    for (; closeHour >= openHour; closeHour--) {     // Labels and positions in reverse order, right to left.
        hourLabels.push(closeHour > 12 ? closeHour % 12 : closeHour);
        labelIndex++;
    }
    if (openHourExact == Math.ceil(openHourExact) && closeHourExact == Math.floor(closeHourExact)) {
        labelIndex--;
    }
	
    // Now calculate the hour positions to maximize space on the left and right if the market opens and/or closes off even hours.
    var hourPositions = [];
    var positionAtRight = 1.0;
    var gapForEachLabel = 1.0 / labelIndex;
	
    // Calculate the amount to append to the second to last hour to show enough of the partial last hour.
    var hourFractionToAppend = Math.min(marketclose.getMinutes() / 60.0, DAY_CHART_MAX_LABEL_ADJUST);
    if (hourFractionToAppend > 0.0) {
        // Draw a blank vertical line to mark the true end of the graph before the y-scale.
        hourLabels.unshift("");
        hourPositions.unshift(1);
        gapForEachLabel += ((1 - hourFractionToAppend) / labelIndex) / labelIndex;
        labelIndex--;
    }
	
    // Calculate the amount to prepend to the second hour to show enough of the partial first hour.
    var hourFractionToPrepend = Math.min(marketopen.getMinutes() / 60.0, DAY_CHART_MAX_LABEL_ADJUST);
    gapForEachLabel += (hourFractionToPrepend / labelIndex) / labelIndex;

    // Now that gapForEachLabel is finalized, calculate where the first drawn label (at the right) should be, if time was appended.
    positionAtRight -= gapForEachLabel * hourFractionToAppend;

    // And loop to calculate the position of each hour thereafter.
    for(; labelIndex > 0; labelIndex--) {
        hourPositions.push(positionAtRight);
        positionAtRight -= gapForEachLabel;
	}
	
	var incr = 1;
	var kMaxHours = 13;
	while (hourLabels.length/incr > kMaxHours) {
		incr++;
	}
	for (var index = 0; index+incr <= hourLabels.length; index += incr)
	{
		if(!hourPositions[index]) hourPositions[index] = 0;
		labelArray.push([hourLabels[index], hourPositions[index]]);
	}
	
	return labelArray;
}

function dayLabelsForHorizontalAxes (obj, daysPerLabel, realTimePositions) {

	var data = obj.data;
    // Build labels: start at the latest day and work backwards until dayLabelCount days have been encountered
	var labelArray = [];
	var labels = [];
	var dayBoundaryIndexes = [];
    var currentDay = -1;
    var skipDays = daysPerLabel == 1 ? daysPerLabel : 0; // Use first day we find
    var valueIndex = data.length;
    var currentMonth = 0;  // Months are 1-indexed.

	//label in week view is start of that days data, but in month view shows just that point's data
	var labelReflectsBeginningOfPeriod = (daysPerLabel == 1); 

    var valueTime;
    var valueDate;
	var lastDate = null;
	
	var timezoneOffsetInMs = gTimezoneOffsetInMin*60*1000;
	
    while (valueIndex--) {
        valueDate = data[valueIndex].date;
		valueTime = valueDate.getTime() - timezoneOffsetInMs;
		var absoluteDay = Math.floor((valueTime) / 86400000.0);

        if (absoluteDay != currentDay) {

            // Calculate the number of days between this date and the previously processed date (i.e. the date immediately after this date, chronologically)
            var daysSinceCurrentDay = (currentDay == -1) ? 0 : currentDay - absoluteDay;

            if (daysSinceCurrentDay >= 1)
                dayBoundaryIndexes.push(valueIndex);

            // Skip days until daysPerLabel days have been skipped.
            // Note that daysPerLabel is expressed in terms of the true calendar and not the dates represented in _stockValues.
            // For example, there are 7 days between these 5 days: { 1, 2, 3, 4, 7 }
            skipDays -= daysSinceCurrentDay;

            if (skipDays <= 0) 
			{
                skipDays = daysPerLabel; //reset skipDays
				if(!lastDate) lastDate = valueDate; //first time in month view

                // Add label for this day
                var labelString = labelReflectsBeginningOfPeriod ? lastDate.getDate() : valueDate.getDate();

				//-1 signals use equal spacing
				var position = realTimePositions ? valueIndex / (data.length-1) : -1;

				labelArray.push([labelString, position]);
            }
				
            // Remember this absolute day
			lastDate = valueDate;
            currentDay = absoluteDay;
        }
    }

	//we had calculated position based on index's position in data
	//if last trading day in week isn't over, need to recalculate accounting for time bt last data point and end of day
		//use the ratio is currentPosition/dataLength = newPosition/totalLength
		//if totalLength = 1, dataLength is gFinalPointEndPosition
	//gFinalPointEndPosition is calculated in chart_callback
    if (currentChartMode == "1w") 
	{
		labelArray.push([lastDate.getDate(), 0]); //add one more for week view


		var lastTime = data[data.length-1].date.getTime();
		var minutesFromLastPointToClose = (( (obj.max_time.getTime() - lastTime) /1000 % (3600 * 24))) / 60;

	    var gFinalPointEndPosition = 1.0;
        if (minutesFromLastPointToClose > WEEK_CHART_UNFINISHED_MINUTES) {
            var closeMinute = obj.max_time.getHours() * 60.0 + obj.max_time.getMinutes();
            var openMinute = obj.min_time.getHours() * 60.0 + obj.min_time.getMinutes();
            gFinalPointEndPosition -= (minutesFromLastPointToClose / (closeMinute - openMinute)) / 5; //5 = number of days
        }

		if(gFinalPointEndPosition < 1) {
			for(var i = 0; i < labelArray.length-1; i++) {//all but the index 0, which has latest date
				labelArray[i][1] = labelArray[i][1] * gFinalPointEndPosition;
			}
		

			// HACK
			obj.dayproportion = labelArray[0][1] - labelArray[1][1];
		}
    }

	return labelArray;
}

function getMonthArray() {
	return getLocalizedString("Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec").split(" ");
}


function monthLabelsWithInterval (data, interval) {
	var labelArray = [];
	var valueIndex = data.length;
	var lastTime = data[data.length-1].date.getTime();
	var lastMonth = data[data.length-1].date.getMonth();
	var labels = getMonthArray ();
	var skipMonths = interval;
	var firstMonthLabeled = -1;
	var showYearLabels = interval >= 4;

	while (valueIndex--) {
		var currentDate = data[valueIndex].date;
		var currentMonth = currentDate.getMonth();
		
		if(currentMonth != lastMonth)
		{
			skipMonths--;
			if(skipMonths == 0)
			{
				if(firstMonthLabeled == -1)
					firstMonthLabeled = lastMonth;

				var label;
				if(showYearLabels && lastMonth == firstMonthLabeled)
					label = labels[lastMonth].substring(0, 1) + "'" + currentDate.getFullYear().toString().substring(2);
				else
					label = labels[lastMonth]; //print the month we're leaving
				
				labelArray.push([label, valueIndex/(data.length-1)]);

				skipMonths = interval;
			}
				lastMonth = currentMonth;			
		}
	}
	return labelArray;
}









function createXYList(min, max, mode, obj) {
	var pixelsPerY = 46 / (max - min); // 48 = height of graph, 66 inset by 1px
	var data = obj.data;
	var width = kChartCanvasWidth;

	if (mode == "1d") {
		var maxrange = (obj.max_time.getTime() - obj.min_time.getTime())/1000;
		var lastTime = data[data.length-1].date.getTime();
		var range = (lastTime - obj.min_time.getTime())/1000;
		width = width * (range/maxrange);
	}
	else if (mode == "1w" && obj.dayproportion != undefined && obj.dayproportion != null) {
		var lastTime = data[data.length-1].date.getTime();
		var minutesFromLastPointToClose = (( (obj.max_time.getTime() - lastTime) /1000 % (3600 * 24))) / 60;
		var marketMinutes = (obj.marketclose - obj.marketopen)/(1000*60);
		width -= kChartCanvasWidth*obj.dayproportion*(1-(((marketMinutes) - minutesFromLastPointToClose)/(marketMinutes)));
		if (width < kChartCanvasWidth/2) {
			width = kChartCanvasWidth;
		}
	}
	return createXYListAverage (min, max, pixelsPerY, width, data);
}


function createXYListAverage(min, max, pixelsPerY, width, data) {

	var array = new Array();
	var c = data.length;
	var len = data.length;
	var incr = 1;
	
	// Simple "smoothing"
	while (c/incr >= 2*width) {
		incr++;
	}
	c = c/incr;
	
	var pixelsPerX = width / c;
	var currx = 0;
	
	for (var i = 0; i+incr <= len; i += incr) {
		
		// var close = data[i].close - min; // normalize	        
		var close = 0;
		for (var j = 0; j < incr; j++) {
			close += data[i+j].close;
		}
		close = close/incr - min;	// normalize

		array[array.length] = [currx, (46 - (pixelsPerY * close)) + 1];
		
		currx += pixelsPerX;
	}
	
	array[array.length-1][0] = width; // make sure it ends at the right
	
	return array;
}

function tosClick(evt) {
	if (window.widget) {
		widget.openURL("http://info.yahoo.com/legal/us/yahoo/utos/utos-173.html");
	}
}

function yLogoClick(evt) {
	if (window.widget)
	{
		var url = 'http://finance.yahoo.com/q/cq?d=v1';

		// if (currentSelection != null) {
		// 	url += "&s=" + currentSelection.tag;
		// } else
		if (allTheData.length == 0) {
			url += "&s=AAPL";
		}
		else {
			for (var i = 0; i < allTheData.length; i++) {
				var symbol = allTheData[i].symbol;
				url += "&s=" + symbol;
			}
		}
		widget.openURL(url);
	}
}

function logoMabaClick (event)
{
	if (window.widget)
	{
		var url = 'http://maba.wordpress.com/widgets/';
		widget.openURL(url);
	}
}
